Subject: Re: generic 802.11 stack

From: Vladimir Kondratiev <[email-masked]>
Date: Tue, 7 Sep 2004 21:41:54 +0300

On Tuesday 07 September 2004 21:08, David S. Miller wrote:
DS> On Tue, 7 Sep 2004 21:06:24 +0300
DS> Vladimir Kondratiev <[email-masked]> wrote:
DS>
DS> > May be I did not stated the question clearly. This information need to
 be DS> > specified per packet. So question ramains: how to specify PHY info
 per skb. DS>
DS> Use the skb->cb[] area, create:
DS>
DS> struct p80211_skb_cb {
DS>  int rate;
DS>  int channel;
DS>  /* whatever... */
DS> };
DS>
DS> #define P80211_SKB_CB(skb)  ((struct p80211_skb_cb *)((skb)->cb))

This should be done in generic way. This information used to communicate 
berween particular driver and generic stack. For example, Rx PHY info and Tx 
status info should be used for in-stack generic rate scaling algorithm.

To complicate it a bit, cb[] is only 48 bytes long. PHY info may easily exceed 
this size, so it's better to allocate something and free it in destructor.

But again, point is this structure should be generic since it is used by 
stack.